import java.awt.Color;
import java.awt.Graphics;

/**
 * Tela para desenho.
 * 
 */
public class Tela
{
	Graphics g;
	
	public Tela(Graphics g) {
		this.g = g;
		g.setColor(Color.white);
	}
	
	public void triangulo(int x1, int y1,
			int x2, int y2, int x3, int y3, Cor cor) {
		g.setColor(new Color(cor.r, cor.g, cor.b));
		g.fillPolygon(new int[] { x1, x2, x3 },
				new int[] { y1, y2, y3 },
				3);
	}
	
	public void circulo(int cx, int cy, int raio, Cor cor) {
		g.setColor(new Color(cor.r, cor.g, cor.b));
		g.fillOval(cx, cy, raio*2, raio*2);
	}
	
	public void quadrado(int x, int y, int lado, Cor cor) {
		g.setColor(new Color(cor.r, cor.g, cor.b));
		g.fillRect(x, y, lado, lado);
	}
	
	public void retangulo(int x, int y, int largura, int altura, Cor cor) {
	    g.setColor(new Color(cor.r, cor.g, cor.b));
	    g.fillRect(x, y, largura, altura);
	}
	
	public void texto(String texto, int x, int y, Cor cor) {
	    g.setColor(new Color(cor.r, cor.g, cor.b));
	    g.drawString(texto, x, y);
	}
	
}
